Ginkgo: gko::solver::Idr< ValueType > Class Template Reference

| Ginkgo Generated from branch based on main. Ginkgo version 1.11.0 A numerical linear algebra library targeting many-core architectures

Loading...
Searching...
No Matches
gko::solver::Idr< ValueType > Class Template Reference
Linear Operators » Solvers | Linear Operators

IDR(s) is an efficient method for solving large nonsymmetric systems of linear equations. More...

`#include <ginkgo/core/solver/idr.hpp>`

Inheritance diagram for gko::solver::Idr< ValueType >:
[legend]
Collaboration diagram for gko::solver::Idr< ValueType >:
[legend]

## Classes
struct | parameters_type
class | Factory

## Public Types
using | value_type = ValueType
using | transposed_type = Idr<ValueType>
Public Types inherited from gko::EnablePolymorphicAssignment< Idr< default_precision > >
using | result_type

## Public Member Functions
std::unique_ptr< LinOp > | transpose () const override
| Returns a LinOp representing the transpose of the Transposable object.
std::unique_ptr< LinOp > | conj_transpose () const override
| Returns a LinOp representing the conjugate transpose of the Transposable object.
bool | apply_uses_initial_guess () const override
| Return true as iterative solvers use the data in x as an initial guess.
size_type | get_subspace_dim () const
| Gets the subspace dimension of the solver.
void | set_subspace_dim (const size_type other)
| Sets the subspace dimension of the solver.
remove_complex< ValueType > | get_kappa () const
| Gets the kappa parameter of the solver.
void | set_kappa (const remove_complex< ValueType > other)
| Sets the kappa parameter of the solver.
bool | get_deterministic () const
| Gets the deterministic parameter of the solver.
void | set_deterministic (const bool other)
| Sets the deterministic parameter of the solver.
bool | get_complex_subspace () const
| Gets the complex_subspace parameter of the solver.
void | set_complex_subpsace (const bool other)
| Sets the complex_subspace parameter of the solver.
void | set_complex_subspace (const bool other)
| Sets the complex_subspace parameter of the solver.
const parameters_type & | get_parameters () const
Public Member Functions inherited from gko::EnableLinOp< Idr< default_precision > >
const Idr< default_precision > * | apply (ptr_param< const LinOp > b, ptr_param< LinOp > x) const
Public Member Functions inherited from gko::EnablePolymorphicAssignment< Idr< default_precision > >
void | convert_to (result_type *result) const override
void | move_to (result_type *result) override
Public Member Functions inherited from gko::solver::EnableSolverBase< Idr< default_precision > >
EnableSolverBase & | operator= (const EnableSolverBase &other)
| Creates a shallow copy of the provided system matrix, clones it onto this executor if executors don't match.
int | get_num_workspace_ops () const override
std::vector< std::string > | get_workspace_op_names () const override
std::vector< int > | get_workspace_scalars () const override
| Returns the IDs of all scalars (workspace vectors with system dimension-independent size, usually 1 x num_rhs).
std::vector< int > | get_workspace_vectors () const override
| Returns the IDs of all vectors (workspace vectors with system dimension-dependent size, usually system_matrix_size x num_rhs).
Public Member Functions inherited from gko::solver::SolverBase< LinOp >
std::shared_ptr< const LinOp > | get_system_matrix () const
| Returns the system matrix, with its concrete type, used by the solver.
Public Member Functions inherited from gko::solver::EnableIterativeBase< Idr< default_precision > >
EnableIterativeBase & | operator= (const EnableIterativeBase &other)
| Creates a shallow copy of the provided stopping criterion, clones it onto this executor if executors don't match.
void | set_stop_criterion_factory (std::shared_ptr< const stop::CriterionFactory > new_stop_factory) override
| Sets the stopping criterion of the solver.
Public Member Functions inherited from gko::solver::IterativeBase
std::shared_ptr< const stop::CriterionFactory > | get_stop_criterion_factory () const
| Gets the stopping criterion factory of the solver.
Public Member Functions inherited from gko::solver::EnablePreconditionable< Idr< default_precision > >
void | set_preconditioner (std::shared_ptr< const LinOp > new_precond) override
| Sets the preconditioner operator used by the Preconditionable.
EnablePreconditionable & | operator= (const EnablePreconditionable &other)
| Creates a shallow copy of the provided preconditioner, clones it onto this executor if executors don't match.
Public Member Functions inherited from gko::Preconditionable
virtual std::shared_ptr< const LinOp > | get_preconditioner () const
| Returns the preconditioner operator used by the Preconditionable.

## Static Public Member Functions
static auto | build () -> decltype(Factory::create())
static parameters_type | parse (const config::pnode &config, const config::registry &context, const config::type_descriptor &td_for_child=config::make_type_descriptor< ValueType >())
| Create the parameters from the property_tree.

## Friends
class | EnableLinOp< Idr >
class | EnablePolymorphicObject< Idr, LinOp >

## Detailed Description

template<typename ValueType = default_precision>
class gko::solver::Idr< ValueType >

IDR(s) is an efficient method for solving large nonsymmetric systems of linear equations.

The implemented version is the one presented in the paper "Algorithm 913: An elegant IDR(s) variant that efficiently exploits biorthogonality properties" by M. B. Van Gijzen and P. Sonneveld.

The method is based on the induced dimension reduction theorem which provides a way to construct subsequent residuals that lie in a sequence of shrinking subspaces. These subspaces are spanned by s vectors which are first generated randomly and then orthonormalized. They are stored in a dense matrix.

Template Parameters

  ValueType | precision of the elements of the system matrix.

## Member Function Documentation

## ◆ apply_uses_initial_guess()

template<typename ValueType = default_precision>

bool gko::solver::Idr< ValueType >::apply_uses_initial_guess | ( |  | ) | const
| inlineoverride

Return true as iterative solvers use the data in x as an initial guess.

Returns
  true as iterative solvers use the data in x as an initial guess.

## ◆ conj_transpose()

template<typename ValueType = default_precision>

std::unique_ptr< LinOp > gko::solver::Idr< ValueType >::conj_transpose | ( |  | ) | const
| overridevirtual

Returns a LinOp representing the conjugate transpose of the Transposable object.

Returns
  a pointer to the new conjugate transposed object

Implements gko::Transposable.

## ◆ get_complex_subspace()

template<typename ValueType = default_precision>

bool gko::solver::Idr< ValueType >::get_complex_subspace | ( |  | ) | const
| inline

Gets the complex_subspace parameter of the solver.

Returns
  the complex_subspace parameter

## ◆ get_deterministic()

template<typename ValueType = default_precision>

bool gko::solver::Idr< ValueType >::get_deterministic | ( |  | ) | const
| inline

Gets the deterministic parameter of the solver.

Returns
  the deterministic parameter

## ◆ get_kappa()

template<typename ValueType = default_precision>

remove_complex< ValueType > gko::solver::Idr< ValueType >::get_kappa | ( |  | ) | const
| inline

Gets the kappa parameter of the solver.

Returns
  the kappa parameter

## ◆ get_subspace_dim()

template<typename ValueType = default_precision>

size_type gko::solver::Idr< ValueType >::get_subspace_dim | ( |  | ) | const
| inline

Gets the subspace dimension of the solver.

Returns
  the subspace Dimension

## ◆ parse()

template<typename ValueType = default_precision>

parameters_type gko::solver::Idr< ValueType >::parse | ( | const config::pnode & | config,
|  | const config::registry & | context,
|  | const config::type_descriptor & | td_for_child = config::make_type_descriptor< ValueType >() )
| static

Create the parameters from the property_tree.

Because this is directly tied to the specific type, the value/index type settings within config are ignored and type_descriptor is only used for children configs.

Parameters

  config | the property tree for setting
  context | the registry
  td_for_child | the type descriptor for children configs. The default uses the value type of this class.

Returns
  parameters

## ◆ set_complex_subpsace()

template<typename ValueType = default_precision>

void gko::solver::Idr< ValueType >::set_complex_subpsace | ( | const bool | other | ) |
| inline

Sets the complex_subspace parameter of the solver.

Parameters

  other | the new complex_subspace parameter

## ◆ set_complex_subspace()

template<typename ValueType = default_precision>

void gko::solver::Idr< ValueType >::set_complex_subspace | ( | const bool | other | ) |
| inline

Sets the complex_subspace parameter of the solver.

Parameters

  other | the new complex_subspace parameter

Referenced by set_complex_subpsace().

## ◆ set_deterministic()

template<typename ValueType = default_precision>

void gko::solver::Idr< ValueType >::set_deterministic | ( | const bool | other | ) |
| inline

Sets the deterministic parameter of the solver.

Parameters

  other | the new deterministic parameter

## ◆ set_kappa()

template<typename ValueType = default_precision>

void gko::solver::Idr< ValueType >::set_kappa | ( | const remove_complex< ValueType > | other | ) |
| inline

Sets the kappa parameter of the solver.

Parameters

  other | the new kappa parameter

## ◆ set_subspace_dim()

template<typename ValueType = default_precision>

void gko::solver::Idr< ValueType >::set_subspace_dim | ( | const size_type | other | ) |
| inline

Sets the subspace dimension of the solver.

Parameters

  other | the new subspace Dimension

## ◆ transpose()

template<typename ValueType = default_precision>

std::unique_ptr< LinOp > gko::solver::Idr< ValueType >::transpose | ( |  | ) | const
| overridevirtual

Returns a LinOp representing the transpose of the Transposable object.

Returns
  a pointer to the new transposed object

Implements gko::Transposable.

The documentation for this class was generated from the following file:

- ginkgo/core/solver/idr.hpp